#!/bin/bash
#
# This script is executed only once, immediately after the image
# tarball is unpacked to the app partition (/usr/local).
#

# update ld.so.cache
mount -oremount,rw /
/sbin/ldconfig

if [ ! -c /dev/bfpga ] ; then
	mknod /dev/bfpga c 254 0
fi

if [ ! -f /usr/lib/mod_auth.so ] ; then
    cp /usr/local/conf/mod_auth.so /usr/lib/
    cp /usr/local/conf/lighttpd.conf /etc/
fi


if ! grep VERSION /etc/init.d/S40network > /dev/null ; then
    cp /usr/local/conf/S40network /etc/init.d/
fi

mount -oremount,ro /


if [ ! -d /usr/local/www/api ] ; then
    mkdir -p /usr/local/www/api
fi

if [ ! -f /usr/conf/apiusers.conf ] ; then
    echo "admin:admin" > /usr/conf/apiusers.conf
fi

if [ ! -f /usr/conf/isgw.tones ] ; then
	cp /usr/local/conf/isgw.tones /usr/conf
fi


MTU=$(/usr/local/bin/beroconf get root lan-mtu)

if [ "$MTU" = "1500" ] ; then
        /usr/local/bin/beroconf set root lan-mtu 500
fi

/usr/bin/env -i bash -c "/usr/bin/php-cgi /usr/local/www/berogui/includes/create_files.php  > /dev/null"

