<?php


/**
 * Klasse General
 * Zeigt algemeine Einstellungen von der isgw.conf Datei
 */

class General {
	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	function display($args) {

		// args
		$m = $_GET['m'];

		$general_table = $this->dynamic_table();
		// build page content
		$ret .= "
					<form class='extensions_form' name='general' action='' method='POST' 
					onsubmit='return (verify_number(port.value, \"Logging Server Port\") && 
					verify_number(telnet_range.value, \"Telnet ACL Range\") && 
					verify_range(telnet_range.value, \"Telnet ACL Range\") && 
					verifyIP(telnet_ip.value));'>
					<input type=hidden name=m value=" . $m . ">
					<input type=hidden name=a value='save'>
					<br>
					" . $general_table;

		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}

	/*
	 * Der reguläre Ausdruck, der in der Datenbank gespeichert ist wird zurückgegeben 
	 * und nachher angezeigt.
	 */

	/*
	 * Die Adresse von dem Loging Server, die in der Datenbank gespeichert ist wird zurückgegeben 
	 * und nachher angezeigt.
	 */
	function address() {
		$ba = new beroAri();
		$query = $ba->select("select logserver from general");
		while ($entry = $ba->fetch_array($query)) {
			$ret = split(":", $entry['logserver']);
			return $ret[0];
		}
	}
	/*
	 * Die msp_device_ip, die in der Datenbank gespeichert ist wird zurückgegeben 
	 * und nachher angezeigt das Feld ist nicht editierbar.
	 */
	
	function msp_device_ip() {
		$tmp = split("\.",ip_address,4);
		if (($tmp[0]>=0) && ($tmp[0]<=255)){
			$tmp[0]++;
		}elseif($tmp[0]==255){
			$tmp[0]--;
		}
		if (($tmp[3]>=0) && ($tmp[3]<=255)){
			$tmp[3]++;
		}elseif($tmp[3]==255){
			$tmp[3]--;
		}
		$ip=$tmp[0].".".$tmp[1].".".$tmp[2].".".$tmp[3];
		$ba = new beroAri();
		$query = $ba->select("select msp_device_ip from general");
		while ($entry = $ba->fetch_array($query)) {
			if ($entry['msp_device_ip']==$ip){
				return $entry['msp_device_ip'];
			}else{
				$query = $ba->update("update general set msp_device_ip='$ip'");
				$query=$ba->select("select option from activate");
				while($entry = $ba->fetch_array($query)){
					if ($entry['option'] <= 2) $query =  $ba->update("UPDATE activate SET option=2");
				}
				return $entry['msp_device_ip'];
			}
		}
	}


	/*
	 * Das Loglevel für Debuggingmode, das in der Datenbank gespeichert ist wird zurückgegeben 
	 * und nachher angezeigt.
	 */

	function loglevel() {
		$ba = new beroAri();
		$query = $ba->select("select loglevel from general");
		$ret.="<select name='loglevel' onmouseover=\"Tip('" . GENERAL_LOGLEVEL . "')\" onmouseout='UnTip()'>";
		while ($entry = $ba->fetch_array($query)) {
			for ($i=0;$i<=9;$i++){
				if ($i==$entry['loglevel']){
					$ret.="<option value='$i' selected>$i</option>";
				}else{
					$ret.="<option value='$i'>$i</option>";
				}
			}
		}
		$ret.="</select>";
		return $ret;
	}
	
	function telnet_acl(){
		$ba = new beroAri();
		$query = $ba->select("select telnet_acl from general");
		$telnet_acl=sqlite_fetch_single($query);
		$data=split("/",$telnet_acl);
		return "<input type='text' name='telnet_ip' value='".$data[0]."' size='15'> / 
				<input type='text' name='telnet_range' value='".$data[1]."' size='2'>";
	}

	/*
	 * Das Port von dem Loging Server, das in der Datenbank gespeichert ist wird zurückgegeben 
	 * und nachher angezeigt.
	 */
	function port() {
		$ba = new beroAri();
		$query = $ba->select("select logserver from general");
		while ($entry = $ba->fetch_array($query)) {
			$ret = split(":", $entry['logserver']);
			return $ret[1];
		}
	}

	/*
	 * Der boolesche Wert von Loging Active, der in der Datenbank gespeichert ist wird zurückgegeben 
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */
	function active() {
		$ba = new beroAri();
		$query = $ba->select("select logging_active from general");
		while ($entry = $ba->fetch_array($query)) {
			if ($entry['logging_active'] == "1") {
				return "<input type='checkbox' name='active' value='1' onmouseover=\"Tip('" . GENERAL_ACTIVE . "')\" onmouseout='UnTip()' checked>";
			} else {
				return "<input type='checkbox' name='active' value='1' onmouseover=\"Tip('" . GENERAL_ACTIVE . "')\" onmouseout='UnTip()'>";
			}
		}
	}

	function show_app() {
		$ba = new beroAri();
		$query = $ba->select("select show_app from set_app");
		while ($entry = $ba->fetch_array($query)) {
			if ($entry['show_app'] == "1") {
				return "<input type='checkbox' name='show_app' value='1' onmouseover=\"Tip('" . GENERAL_ENABLE_API . "')\" onmouseout='UnTip()' checked>";
			} else {
				return "<input type='checkbox' name='show_app' value='1' onmouseover=\"Tip('" . GENERAL_ENABLE_API . "')\" onmouseout='UnTip()'>";
			}
		}
	}
	
	/*
	 * Funktion dynamic_table
	 */

	function dynamic_table() {
		//Wenn man Änderugen von der Daten macht werden die in der Tabelle der Datenbank
		//aktualisiert
		if (isset($_POST['address']) || isset($_POST['ports'])) {
			$ba = new beroAri();
			if (($_POST['address'] != "") && ($_POST['port'] != "")) {
				$query = $ba->update("update general set logserver='" . $_POST['address'] . ":" . $_POST['port'] . "'");
			}
			if ($_POST['active'] == "1") {
				$query = $ba->update("update general set logging_active='" . $_POST['active'] . "'");
			} else {
				$query = $ba->update("update general set logging_active='0'");
			}
			if ($_POST['show_app'] == "1") {
				$query = $ba->update("update set_app set show_app='" . $_POST['show_app'] . "'");
			} else {
				$query = $ba->update("update set_app set show_app='0'");
			}
			if ($_POST['loglevel'] != "") {
				$query = $ba->update("update general set loglevel='" . $_POST['loglevel'] . "'");
			}
			if (($_POST['telnet_ip'] != "") && ($_POST['telnet_range'] != "")) {
				$query = $ba->update("update general set telnet_acl='" . $_POST['telnet_ip'] . "/" . $_POST['telnet_range'] . "'");
			}
			$query=$ba->select("select option from activate");
			while($entry = $ba->fetch_array($query)){
				if ($entry['option'] <= 2) $query =  $ba->update("UPDATE activate SET option=2");
			}
		}		
		$table = "<table class='contenttoc' id='table'>
					<tr>
					<th colspan='2'>Logging</th>
					</tr>
					<tr>
					<td><b>Logging Server:</b></td>
					<td><input type='text' name='address' value='" . $this->address() . "' onmouseover=\"Tip('" . GENERAL_ADDRESS . "')\" onmouseout='UnTip()'></td>
					</tr>
					<tr>
					<td><b>Logging Server Port:</b></td>
					<td><input type='text' name='port' value='" . $this->port() . "' onmouseover=\"Tip('" . GENERAL_PORT . "')\" onmouseout='UnTip()'></td>
					</tr>
					<tr>
					<td><b>Logging Active:</b></td>
					<td>" . $this->active() . "</td>
					</tr>
					<tr>
					<td><b>Log Level:</b></td>
					<td>" . $this->loglevel() . "</td>
					</tr>
					<tr>
					<td><b>Enable API:</b></td>
					<td>" . $this->show_app() . "</td>
					</tr>
					<tr>
					<td><b>Telnet ACL:</b></td>
					<td>" . $this->telnet_acl() . "</td>
					</tr>
					<!--
					<tr>
					<td><b>MSP Device IP:</b></td>
					<td><input type='text' name='msp' value='" . $this->msp_device_ip() . "' disabled='true' onmouseover=\"Tip('" . GENERAL_MSP . "')\" onmouseout='UnTip()'></td>
					</tr>
					-->
					</table>
					<br>
					<input name='submit' type='submit' value='Save' onmouseover=\"Tip('" . GENERAL_SAVE . "')\" onmouseout='UnTip()'>
					</form>";
		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf 					
		return $table;
	}

}
?>

